searchNodes=[{"doc":"Defines a RabbitMQ client. Example usage defmodule MyApp.RabbitMQ do use Lepus , client : Lepus.BasicClient end Add Lepus.BasicClient to your supervision tree (see the Lepus.BasicClient documentation). Use it to publish a message to Rabbit MQ: MyApp.RabbitMQ . publish_json ( &quot;my-exchange&quot; , &quot;my-routing-key&quot; , %{ a : 1 , b : 2 } ) Testing For testing purposes you can use another :client . It could be Mox mock. defmodule MyApp.RabbitMQ do use Lepus , client : Application . get_env ( :my_app , __MODULE__ , [ ] ) |&gt; Keyword . fetch! ( :client ) end In the prod.exs or dev.exs : config :my_app , MyApp.RabbitMQ , client : Lepus.BasicClient In the test.exs : config :my_app , MyApp.RabbitMQ , client : MyApp.RabbitMQClientMock In the tests: test &quot;uses Mox for Lepus&quot; do MyApp.RabbitMQClientMock |&gt; expect ( :publish_json , fn _ , &quot;my-exchange&quot; , &quot;my-routing-key&quot; , payload , _opts -&gt; assert %{ my_key : &quot;My Value&quot; } = payload end ) MyApp.RabbitMQ . publish_json ( &quot;my-exchange&quot; , &quot;my-routing-key&quot; , %{ my_key : &quot;My Value&quot; } ) end","ref":"Lepus.html","title":"Lepus","type":"behaviour"},{"doc":"Publishes message to RabbitMQ exchange. Options amqp_opts - AMQP.Basic.publish/5 options. rpc - Defines if the message uses RPC pattern. The default value is false . timeout - number of milliseconds or :infinity . Valid for RPC . The default value is 5000 . Returns Without rpc: true : :ok - in case of success {:error, any} in case of error With rpc: true : {:ok, any} - in case of success {:error, :timeout} - in case of timeout error {:error, any} - in case of error","ref":"Lepus.html#c:publish/4","title":"Lepus.publish/4","type":"callback"},{"doc":"The same as publish/4 but payload can be any type that is convertable to JSON (map, list, etc.). Sends JSON string to RabbitMQ exchange.","ref":"Lepus.html#c:publish_json/4","title":"Lepus.publish_json/4","type":"callback"},{"doc":"Basic Lepus.Client implementation. Features Supervises AMQP.Connection process and many AMQP.Channel processes (one AMQP.Channel process per exchange). Supports RPC Example usage Add it to your supervision tree children = [ { Lepus.BasicClient , name : MyApp.RabbitMQ , exchanges : [ &quot;exchange1&quot; , &quot;exchange2&quot; ] , connection : [ host : &quot;localhost&quot; , port : 5672 , virtual_host : &quot;/&quot; , username : &quot;guest&quot; , password : &quot;guest&quot; ] , rpc_opts : [ pubsub : MyApp.PubSub , reply_to_queue : &quot;my_app.reply_to&quot; ] } ] children |&gt; Supervisor . start_link ( strategy : :one_for_one ) Options :name - Required. Module name of your client. If you use defmodule MyApp.RabbitMQ do use Lepus , client : Lepus.BasicClient end the name should be MyApp.RabbitMQ . :connection - Required. Defines an AMQP URI or a set of options used by the RabbitMQ client to open the connection with the RabbitMQ broker. See AMQP.Connection.open/1 for the full list of options. :exchanges - List of exchange names you are going to use. Lepus.BasicClient starts and supervises separate process per exchange. Process for the default exchange ( &quot;&quot; ) is always started. The default value is [] . :rpc_opts - Required only if you are going to use RPC ( Lepus.publish/4 or Lepus.publish_json/4 with rpc: true ). The default value is [] . :pubsub - Your PubSub process name. See the Phoenix.PubSub . :reply_to_queue - Defines a queue name for the replies. :queues_type - Defines reply_to queue type (one of [&quot;classic&quot;, &quot;quorum&quot;] ). Used during queue declaration.","ref":"Lepus.BasicClient.html","title":"Lepus.BasicClient","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Lepus.BasicClient.html#child_spec/1","title":"Lepus.BasicClient.child_spec/1","type":"function"},{"doc":"","ref":"Lepus.BasicClient.html#start_link/1","title":"Lepus.BasicClient.start_link/1","type":"function"},{"doc":"Client behaviour used in Lepus .","ref":"Lepus.Client.html","title":"Lepus.Client","type":"behaviour"},{"doc":"","ref":"Lepus.Client.html#c:publish/5","title":"Lepus.Client.publish/5","type":"callback"},{"doc":"","ref":"Lepus.Client.html#c:publish_json/5","title":"Lepus.Client.publish_json/5","type":"callback"},{"doc":"","ref":"Lepus.Client.html#t:binary_payload/0","title":"Lepus.Client.binary_payload/0","type":"type"},{"doc":"","ref":"Lepus.Client.html#t:exchange/0","title":"Lepus.Client.exchange/0","type":"type"},{"doc":"","ref":"Lepus.Client.html#t:opts/0","title":"Lepus.Client.opts/0","type":"type"},{"doc":"","ref":"Lepus.Client.html#t:payload/0","title":"Lepus.Client.payload/0","type":"type"},{"doc":"","ref":"Lepus.Client.html#t:response/0","title":"Lepus.Client.response/0","type":"type"},{"doc":"","ref":"Lepus.Client.html#t:routing_key/0","title":"Lepus.Client.routing_key/0","type":"type"},{"doc":"Consumer receives messages from a RabbitMQ queue. It uses Broadway and BroadwayRabbitMQ.Producer under the hood. Features Optionally retries failed messages with exponential backoff Optionally publishes failed messages to separate queue Supports RPC Topology ┌► [queue] │ │ │ ▼ │ (Lepus.Consumer) ───► {failed exchange} ───► [failed queue] │ │ │ ▼ │ {delay exchange} │ │ │ ▼ │ [retry queue] │ │ │ ▼ └ {retry exchange} Example Define a consumer: defmodule MyApp.MyConsumer do @behaviour Lepus.Consumer @impl Lepus.Consumer def options do [ connection : [ host : &quot;localhost&quot; , port : 5672 , virtual_host : &quot;/&quot; , username : &quot;guest&quot; , password : &quot;guest&quot; ] , exchange : &quot;my_exchange&quot; , routing_key : &quot;my_routing_key&quot; , queue : &quot;my_queue&quot; , store_failed : true , max_retry_count : 5 ] end @impl Lepus.Consumer def handle_message ( data , metadata ) do Do . something_with ( data , metadata ) end end Then add it to your supervision tree (usually in lib/my_app/application.ex ): children = [ { Lepus.Consumer , consumers : [ MyApp.MyConsumer ] } ] children |&gt; Supervisor . start_link ( strategy : :one_for_one ) You can also define some global options for all the consumers in the supervision tree: children = [ { Lepus.Consumer , consumers : [ MyApp.MyConsumer , MyApp.OtherConsumer ] , options : [ connection : rabbit_connection , exchange : &quot;my_exchange&quot; ] } ] children |&gt; Supervisor . start_link ( strategy : :one_for_one )","ref":"Lepus.Consumer.html","title":"Lepus.Consumer","type":"behaviour"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Lepus.Consumer.html#child_spec/1","title":"Lepus.Consumer.child_spec/1","type":"function"},{"doc":"Receives message payload and metadata . payload Usually it's a binary RabbitMQ message payload. But it could be parsed JSON (map, list, etc.) if content type of the message is &quot;application/json&quot; or it was sent via Lepus.publish_json/4 metadata It's a map with the keys: rpc - Defines if the message was sent using RPC pattern ( reply_to and correlation_id is not empty). The function should return {:ok, result} if rpc is true . retry_count - Count of retries if the message was retried. Otherwise 0 . retriable – Defines if the message will be retried in case of error. client – &quot;lepus&quot; if the message was sent via Lepus.publish/4 or Lepus.publish_json/4 . rabbit_mq_metadata - metadata field from BroadwayRabbitMQ.Producer . Should return in case of using RPC: {:ok, response} – so Lepus.publish/4 or Lepus.publish_json/4 returns {:ok, response} {:error, response} – so Lepus.publish/4 or Lepus.publish_json/4 returns {:error, response} Should return in case of not using RPC: :ok – exists successfully. :error – exits with error. The message could be retried if max_retry_count &gt; 0 . {:error, error_message} – The same as :error but adds the error_message to RabbitMQ headers. :retry – always retries message (even if max_retry_count == 0 ). {:retry, reason} – The same as :retry but adds the reason to RabbitMQ headers.","ref":"Lepus.Consumer.html#c:handle_message/2","title":"Lepus.Consumer.handle_message/2","type":"callback"},{"doc":"Should return keyword list of options (if defined). You can also define options in the supervision tree as described above. Options :connection - Required. Defines an AMQP URI or a set of options used by the RabbitMQ client to open the connection with the RabbitMQ broker. See AMQP.Connection.open/1 for the full list of options. :exchange - Required. The name of the RabbitMQ exchange. :routing_key - Required. The name of the RabbitMQ routing_key. :delay_exchange - Redefines delay exchange name. The default value is &quot;\#{exchange}.delay&quot; :retry_exchange - Redefines retry exchange name. The default value is &quot;\#{exchange}.retry&quot; :failed_exchange - Redefines error exchange name. The default value is &quot;\#{exchange}.failed&quot; :queue - Redefines queue name. The default value is &quot;\#{exchange}.\#{routing_key}&quot; :retry_queue - Redefines retry queue name. The default value is &quot;\#{queue}.retry&quot; :failed_queue - Redefines error queue name. The default value is &quot;\#{queue}.failed&quot; :processor - Broadway processor options. Only one processor is used. See Broadway.start_link/2 for the full list of options. The default value is [] . :max_retry_count - The maximum count of message retries. The default value is 0 . :store_failed - Defines if the failed message should be published to failed_queue . The default value is false . :queues_type - Defines queues type (one of [&quot;classic&quot;, &quot;quorum&quot;] ). Used during queue declaration. The default value is &quot;classic&quot; .","ref":"Lepus.Consumer.html#c:options/0","title":"Lepus.Consumer.options/0","type":"callback"},{"doc":"","ref":"Lepus.Consumer.html#start_link/1","title":"Lepus.Consumer.start_link/1","type":"function"},{"doc":"","ref":"Lepus.Consumer.html#t:metadata/0","title":"Lepus.Consumer.metadata/0","type":"type"},{"doc":"","ref":"Lepus.Consumer.html#t:payload/0","title":"Lepus.Consumer.payload/0","type":"type"},{"doc":"Opinionated library for RabbitMQ .","ref":"readme.html","title":"Lepus","type":"extras"},{"doc":"HexDocs","ref":"readme.html#documentation","title":"Lepus - Documentation","type":"extras"},{"doc":"Supervises AMQP.Connection and AMQP.Channel processes. Optionally retries failed messages with exponential backoff. Optionally publishes failed messages to separate queue. Supports RPC .","ref":"readme.html#features","title":"Lepus - Features","type":"extras"},{"doc":"Add :lepus to the list of dependencies in mix.exs : def deps do [ { :lepus , &quot;~&gt; 0.1.0&quot; } , ] end","ref":"readme.html#installation","title":"Lepus - Installation","type":"extras"}]